#define pix 19
#include <tinyNeoPixel.h>
tinyNeoPixel pixels = tinyNeoPixel(pix, 0   , NEO_GRB + NEO_KHZ800);

void setup(){
  
  pixels.begin();
  pixels.show();
  pinMode(0, OUTPUT);
  Serial.begin(9600);
}

void loop(){

 task3(30);
 
  if (Serial.available() >0){
    char indata = Serial.read();
    if (indata == 'a' ){
    Serial.println("printing 1"); //Blue
    task1();
    delay(5000);
    }
  

    else if (indata == 'b'  ){
     Serial.println("printing 2"); // Red
     task2();
     delay(5000);
    }

    else if (indata == 'c' ){
     Serial.println("printing 3"); //green
     task3(50);
     delay(5000);
 }
    else if (indata == 'd' ){
     Serial.println("printing 3"); //green
     task4(50);
     delay(5000);

  
 }
 else if (indata == 'e' ){
     Serial.println("printing 3"); //green
     task5(pixels.Color(255, 0, 0), 50);;
     delay(5000);

  
 
  }

  else if (indata == 'f' ){
     Serial.println("printing 3"); //green
     task5(pixels.Color(0, 255, 0), 50);;
     delay(5000);

  
 
  }
}
 

}
void task1(){
  Serial.println("printing task 1");

  for(int i=0; i<pix; i++) {
 pixels.setPixelColor(i, pixels.Color(0, 0, 150));
 pixels.show(); 
  }
  delay(1);
  for(int i=0; i<pix; i++) {
 pixels.setPixelColor(i, pixels.Color(0, 0, 150));
 pixels.show(); 
  }
  delay(1000);
  
}
void task2(){ 
  Serial.println("printing task 2");
  
  for(int i=0; i<pix; i++) {
  pixels.setPixelColor(i, pixels.Color(150, 0, 0));
  pixels.show();
  
  }
  delay(1);
   for(int i=0; i<pix; i++) {
  pixels.setPixelColor(i, pixels.Color(150, 0, 0));
  pixels.show();
  
  }
  delay(1000);
}

void task3(uint8_t wait) {
  uint16_t i, j;

  for (j = 0; j < 256; j++) {
    for (i = 0; i < pixels.numPixels(); i++) {
      pixels.setPixelColor(i, Wheel((i + j) & 255));
    }
    pixels.show();
    delay(wait);
  }
}

void task4(uint8_t wait) {
  for (int j = 0; j < 256; j++) {   // cycle all 256 colors in the wheel
    for (int q = 0; q < 3; q++) {
      for (uint16_t i = 0; i < pixels.numPixels(); i = i + 3) {
        pixels.setPixelColor(i + q, Wheel((i + j) % 255)); //turn every third pixel on
      }
      pixels.show();

      delay(wait);

      for (uint16_t i = 0; i < pixels.numPixels(); i = i + 3) {
        pixels.setPixelColor(i + q, 0);      //turn every third pixel off
      }
    }
  }
}

void task5(uint32_t c, uint8_t wait) {
  for (uint16_t i = 0; i < pixels.numPixels(); i++) {
    pixels.setPixelColor(i, c);
    pixels.show();
    delay(wait);
  }
}

uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if (WheelPos < 85) {
    return pixels.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  if (WheelPos < 170) {
    WheelPos -= 85;
    return pixels.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  WheelPos -= 170;
  return pixels.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
}
